
%global meadversion 3.0.9
%global namedversion 3.0.9.GA-redhat-1
%global meadalpha .GA_redhat_1
%global meadrel .1
%global serial 1

# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define rename xnio
%define origtag .GA
%define reltag  %{origtag}_redhat_1
%define namedreltag %{origtag}-redhat-1

%define maven_version 3.0.9.GA-redhat-1

Name:           jboss-xnio-base
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        XNIO low level IO layer
Group:          Development/Libraries/Java

%if %with mead
Source100: xnio-all-3.0.9.GA-redhat-1-scm-sources.zip
Source102: xnio-nio-3.0.9.GA-redhat-1-javadoc.jar
Source103: xnio-nio-3.0.9.GA-redhat-1.pom
Source104: xnio-nio-3.0.9.GA-redhat-1-sources.jar
Source105: xnio-nio-3.0.9.GA-redhat-1.jar
Source106: xnio-all-3.0.9.GA-redhat-1.pom
Source107: xnio-api-3.0.9.GA-redhat-1.pom
Source108: xnio-api-3.0.9.GA-redhat-1.jar
Source109: xnio-api-3.0.9.GA-redhat-1-sources.jar
Source110: xnio-api-3.0.9.GA-redhat-1-javadoc.jar
%endif

License:        LGPLv2+
URL:            http://jboss.org/xnio/
# git clone https://github.com/xnio/xnio.git
# cd xnio
# git checkout 3.0.3.GA
# cd ..
# tar jcf jboss-xnio-base-3.0.3.GA.tar.bz2 xnio
%if %without mead
Source0:        jboss-xnio-base-%{version}%{origtag}.tar.bz2
Source1:        jboss-xnio-base-jpp-depmap.xml
Patch0:         jboss-xnio-base-vman-pom.patch
%endif
BuildRequires:  jpackage-utils 
Requires(post): jpackage-utils 
Requires(postun): jpackage-utils 

Requires:       jboss-logging
Requires:       jboss-logmanager
Requires:       jpackage-utils
%if %without mead
BuildRequires:  javassist
BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management
BuildRequires:  jboss-logging
BuildRequires:  jboss-logmanager
BuildRequires:  junit

BuildRequires:  maven2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-injection-plugin
%endif
Provides: 	xnio = %{epoch}:%{version}-%{release}

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XNIO is a simplified low-level I/O layer which can be used 
anywhere you are using NIO today. It frees you from the 
hassle of dealing with Selectors and the lack of NIO support 
for multicast sockets and non-socket I/O such as serial 
ports, while still maintaining all the capabilities present 
in NIO. Also, XNIO vastly simplifies implementation of 
channels, opening the door to supporting higer-level 
transport concepts (like SSL or virtual channels) with the 
same simple API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n xnio
%patch0 -p1 
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=jboss-releases::default::file://maven2-brew \
        -Prelease \
        deploy javadoc:aggregate
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
%if %without mead
cp -p api/target/%{rename}-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{rename}-api-%{namedversion}.jar
cp -p nio-impl/target/%{rename}-nio-%{namedversion}.jar %{buildroot}%{_javadir}/%{rename}-nio-%{namedversion}.jar
%else
install -m 644 %{_sourcedir}/%{rename}-api-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{rename}-api-%{namedversion}.jar
install -m 644 %{_sourcedir}/%{rename}-api-%{namedversion}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{rename}-api-%{namedversion}-sources.jar
install -m 644 %{_sourcedir}/%{rename}-nio-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{rename}-nio-%{namedversion}.jar
install -m 644 %{_sourcedir}/%{rename}-nio-%{namedversion}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{rename}-nio-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed  "s|-%{namedversion}||g"`; done)

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%else
%{__unzip} -qq %{_sourcedir}/%{rename}-api-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/%{rename}-api
%{__unzip} -qq %{_sourcedir}/%{rename}-nio-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/%{rename}-nio
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/%{rename}-api/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/%{rename}-nio/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%add_to_maven_depmap org.jboss.xnio xnio-all %{namedversion} JPP xnio-all
%add_to_maven_depmap org.jboss.xnio xnio-api %{namedversion} JPP xnio-api
%add_to_maven_depmap org.jboss.xnio xnio-nio %{namedversion} JPP xnio-nio

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
%if %without mead
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-xnio-all.pom
cp -p api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-xnio-api.pom
cp -p nio-impl/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-xnio-nio.pom
%else
install -m 644 %{_sourcedir}/%{rename}-all-%{namedversion}.pom $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-all.pom
install -m 644 %{_sourcedir}/%{rename}-api-%{namedversion}.pom $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-api.pom
install -m 644 %{_sourcedir}/%{rename}-nio-%{namedversion}.pom $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{rename}-nio.pom
%endif

%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%if %with mead
%{__unzip} -qq %{_sourcedir}/%{rename}-all-%{namedversion}-scm-sources.zip
%{__cp} %{rename}/COPYING.txt .
%{__rm} -rf %{rename}
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc COPYING.txt
%{_javadir}*/xnio-api-%{namedversion}.jar
%{_javadir}*/xnio-api.jar
%{_javadir}*/xnio-api-%{namedversion}-sources.jar
%{_javadir}*/xnio-api-sources.jar
%{_javadir}*/xnio-nio-%{namedversion}.jar
%{_javadir}*/xnio-nio.jar
%{_javadir}*/xnio-nio-%{namedversion}-sources.jar
%{_javadir}*/xnio-nio-sources.jar
%{_datadir}/maven2/poms/JPP-xnio-api.pom
%{_datadir}/maven2/poms/JPP-xnio-nio.pom
%{_datadir}/maven2/poms/JPP-xnio-all.pom
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 14 2014 Paul Gier <pgier@redhat.com> - 3.0.9-1.GA_redhat_1.1
- Fix source zip name

* Tue Jan 14 2014 Paul Gier <pgier@redhat.com> - 3.0.9-1.GA_redhat_1.1
- Rebuild to fix source zip

* Tue Jan 14 2014 Paul Gier <pgier@redhat.com> - 3.0.9-1.GA_redhat_1.1
- Upgrade to 3.0.9.GA

* Fri Oct 05 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.0.7-1.GA_redhat_1
- Upgrade to 3.0.7.GA

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.0.6-2.GA_redhat_1
- Rebuild for MD5

* Thu Sep 13 2012 Hui Wang <huwang@redhat.com> - 0:3.0.6-1.GA_redhat_1
- Upgrade to 3.0.6.GA

* Tue Aug 29 2012 Hui Wang <huwang@redhat.com> - 0:3.0.5-1.GA_redhat_1
- Upgrade to 3.0.5.GA

* Mon Aug 20 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:3.0.4-3.GA_redhat_2.2
- Update poms for eap 6.0.1

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.0.4-2.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.0.4-2.GA_redhat_1.1
- Rebuild using cache signing

* Thu May 24 2012 Fernando Nasser <fnasser@redhat.com>- 0:3.0.4-2.GA_redhat_1
- Remove javadocs foro nio as only the api part is public

* Thu May 24 2012 Hui Wang <huwang@redhat.com>- 0:3.0.4-1.GA_redhat_1
- Upgrade to 3.0.4.GA
- Fix installation path
- Enable javadoc subpackage

* Mon Mar 12 2012 Hui Wang <huwang@redhat.com>- 0:3.0.3-1.GA_redhat_1.2
- Use the binaries built in MEAD

* Fri Feb 17 2012 Hui Wang <huwang@redhat.com> 0:3.0.3-1.GA_redhat_1.1
- Upgrade to 3.0.3.GA

* Mon Jan 16 2012 Martha Benitez <mbenitez@redhat.com> 0:3.0.0-0.2.GA_redhat_1.1
- Adjust Release and add it to Provides: xnio

* Mon Jan 16 2012 Martha Benitez <mbenitez@redhat.com> 0:3.0.0-0.1.GA_redhat_1.1
- Add Provides: xnio

* Fri Jan 06 2012 Hui Wang <huwang@redhat.com> 0:3.0.0-0.1.GA_redhat_1
- Upgrade to 3.0.0.GA

* Wed Dec 14 2011 Hui Wang <huwang@redhat.com> 0:3.0.0-0.1.CR5_redhat_1
- Upgrade to 3.0.0.CR5

* Sat Nov 26 2011 Hui Wang <huwang@redhat.com> 0:3.0.0-0.1.CR4_redhat_1
- Upgrade to 3.0.0.CR4

* Tue Nov 22 2011 Hui Wang <huwang@redhat.com> 0:3.0.0-0.1.CR3_redhat_1
- Upgrade to 3.0.0.CR3
- Add COPYING.txt to files

* Tue Nov 22 2011 Hui Wang <huwang@redhat.com> 0:3.0.0-0.1.Beta8_redhat_1
- Upgrade to 3.0.0.Beta8
- Build with JDK7

* Wed Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:3.0.0-5.Beta3_redhat_1
- remove incorrect maven2 requirement
- fix mvn command
- rebuild for indirect batik/fop dependencies
- fix reltag definition

* Tue Sep 27 2011 Hui Wang <huwang@redhat.com> - 3.0.0-4.Beta3
- Build for wolf
- Cleanup

* Mon Aug 08 2011 Yong Yang <yyang@redhat.com> - 3.0.0-3.Beta3
- Fix dep versions in pom.xml to the versions MEAD repo has

* Mon Aug 08 2011 Yong Yang <yyang@redhat.com> - 3.0.0-2.Beta3
- Build xnio with JDK6

* Tue Aug 2 2011 Lin Gao <lgao@redhat.com> - 3.0.0.Beta3-1
- upgrade to 3.0.0.Beta3
- build using mead
- rename all .patch to .patch.rpmbuild

* Thu Mar 31 2011 David Walluck <dwalluck@redhat.com> 0:1.2.1-6
- fix repolib option
- update License
- update BuildRoot
- Requires: jpackage-utils for main pkg and javadoc pkg
- fix dir ownership in main pkg and repolib pkg
- no bundled jars to remove
- fix patch macros
- don't mark javadoc as %%doc
- update %%defattr
- end repolib description with a dot
- call ant properly
- fix maven deps
- fix component-info.xml sed
- use full version in jar and javadoc dir names
- fix repolib permissions
- use proper macro for build root
- remove bundled bare poms
- use proper mvn-jpp deploy:deploy-file
- use settings.xml for mvn-jpp
- update jboss-xnio-base-build.patch

* Thu Mar 31 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-5
- Rebuild due to signing failure in the last build

* Fri Dec 10 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2.1-4
- Add maven2-brew contents to repolib

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2.1-3.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redha.com> - 0:1.2.1-3
- Rebuild

* Thu Nov 12 2009 Yong Yang <yyang@redhat.com> - 0:1.2.1-2
- Add repolib

* Fri Sep 18 2009 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-1
- Upgrade to 1.2.1.GA

* Mon Aug 31 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.2.0-1
- First release
